/************************************************************************************/
/*  Program name CAPFNDEXT_ORG_UNITS_TL.sql                                         */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 16 JAN, 2005   NIP Karen         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDEXT_ORG_UNITS_TL';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFND_ORG_UNITS_TL.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO			VARCHAR2(100);
	lv_NGO_Count	NUMBER;

		CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		T.*
	FROM
		HR_ALL_ORGANIZATION_UNITS_TL	T
	WHERE	SUBSTR(T.Name,4,4)	=	p_NGO;
	
		/*CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		T.*
	FROM
		HR_ALL_ORGANIZATION_UNITS		A,
		HR_ALL_ORGANIZATION_UNITS		O,
		HR_ALL_ORGANIZATION_UNITS_TL	T
	WHERE	SUBSTR(A.Name,4,4)	=	p_NGO
	AND		O.Business_Group_ID	=	A.Organization_ID
	AND		O.Organization_ID	=	T.Organization_ID
	AND		O.Organization_ID	IN
				(
				SELECT	Organization_ID
				FROM	HR_ORGANIZATION_INFORMATION
				WHERE	Org_Information_Context	IN	('Accounting Information','Operating Unit Information')
				);*/

BEGIN
	lv_NGO			:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Organization_ID||CHR(9)||
				C1.Language||CHR(9)||
				C1.Source_Lang||CHR(9)||
				C1.Name||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Created_By)
			);
			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		IF	lv_Scc_Count	=	0	THEN
			lv_Err_Msg	:=	lv_NGO||': No Organization Unit under this business group';
		END IF;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO||': No such BG exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/